#include <cmath>
#include "Auxiliaries.h"
#include "Input_Common.h"

using namespace std;

double OL(double s, double a, double b, double c) {
	return -(128*(1 - s)*s*(1 + s)*(1 + pow(s,2))*log(f(0,t(s))))/(Pi*sqrt((2 - pow(s,4))*(2 - 2*pow(s,4) + pow(s,8))));
}

double CALap(double w, double sl, double c, double z) {
	return -((1024*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*(-8*pow(c,2)*pow(Pi,2)*pow(w,3)*pow(1 + pow(w,4),4)*pow(z,6)*pow(-1 + pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
        (-1 - 4*(-1 + pow(w,4))*pow(z,2) + 6*(-1 + pow(w,4))*pow(z,4) - 4*(-1 + pow(w,4))*pow(z,6) + (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*
        (-67 + 3*pow(Pi,2) - 33*log(-16*pow(sl,4)*(-2 + pow(sl,4))*pow(-1 + pow(sl,4),4)*(2 - 2*pow(sl,4) + pow(sl,8))))*log(f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       (pow(c,2)*pow(Pi,3)*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(w,3)*pow(1 + pow(w,4),4)*pow(-1 + z,3)*
          pow(z,6)*pow(1 + z,3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
          pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
          pow(1 + pow(c,2) + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
          pow(-1 + pow(c,2)*(-1 - 4*(-1 + pow(w,4))*pow(z,2) + 6*(-1 + pow(w,4))*pow(z,4) - 4*(-1 + pow(w,4))*pow(z,6) + (-1 + pow(w,4))*pow(z,8)),2)*(-808 + 33*pow(Pi,2) + 756*Zeta3))/3.))/
   (9.*c*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*z*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
     (1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
     (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
     (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double NFLap(double w, double sl, double c, double z) {
	return -((-4096*c*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*(pow(Pi,2)*(56 - 3*pow(Pi,2))*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*
        pow(1 + pow(w,4),4)*pow(z,10)*pow(w - w*pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*
        pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2) + 
       24*pow(Pi,2)*pow(1 + pow(w,4),4)*pow(z,10)*pow(w - w*pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*
        (5 + 3*log(-16*pow(sl,4)*(-2 + pow(sl,4))*pow(-1 + pow(sl,4),4)*(2 - 2*pow(sl,4) + pow(sl,8))))*log(f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl)))))/
   (27.*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*pow(z,5)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
     (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
     (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double CFLap(double x, double s, double a, double b) {
	return 1.;
}

double CAMom(double w, double sl, double c, double z) {
	return -((1024*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*(-8*pow(c,2)*pow(Pi,2)*pow(w,3)*pow(1 + pow(w,4),4)*pow(z,6)*pow(-1 + pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
        (-1 - 4*(-1 + pow(w,4))*pow(z,2) + 6*(-1 + pow(w,4))*pow(z,4) - 4*(-1 + pow(w,4))*pow(z,6) + (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*
        (-67 + 3*pow(Pi,2) - 33*log(-16*pow(sl,4)*(-2 + pow(sl,4))*pow(-1 + pow(sl,4),4)*(2 - 2*pow(sl,4) + pow(sl,8))))*log(f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       72*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) - 
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) - 
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) + 
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) - 
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) + 
       (pow(c,2)*pow(Pi,3)*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(w,3)*pow(1 + pow(w,4),4)*pow(-1 + z,3)*
          pow(z,6)*pow(1 + z,3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
          pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
          pow(1 + pow(c,2) + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
          pow(-1 + pow(c,2)*(-1 - 4*(-1 + pow(w,4))*pow(z,2) + 6*(-1 + pow(w,4))*pow(z,4) - 4*(-1 + pow(w,4))*pow(z,6) + (-1 + pow(w,4))*pow(z,8)),2)*(-808 + 33*pow(Pi,2) + 756*Zeta3))/3.))/
   (9.*c*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*z*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
     (1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
     (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
     (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double NFMom(double w, double sl, double c, double z) {
	return -((-4096*c*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*(pow(Pi,2)*(56 - 3*pow(Pi,2))*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*
        pow(1 + pow(w,4),4)*pow(z,10)*pow(w - w*pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*
        pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2) + 
       24*pow(Pi,2)*pow(1 + pow(w,4),4)*pow(z,10)*pow(w - w*pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*
        (5 + 3*log(-16*pow(sl,4)*(-2 + pow(sl,4))*pow(-1 + pow(sl,4),4)*(2 - 2*pow(sl,4) + pow(sl,8))))*log(f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) - 
       216*w*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) - 
          pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl)))))/
   (27.*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*pow(z,5)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
     (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
     (Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double CFMom(double x, double s, double a, double b) {
	return 1.;
}
