#include <cmath>
#include "Auxiliaries.h"
#include "Input_Common.h"

using namespace std;

double OL(double s, double a, double b, double c) {
	return (128*(1 - s)*s*(1 + s)*(1 + pow(s,2))*log(f(0,t(s))))/(Pi*sqrt((2 - pow(s,4))*(2 - 2*pow(s,4) + pow(s,8))));
}

double CALap(double w, double sl, double c, double z) {
	return -((1024*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*w*(-8*pow(c,2)*Pi*pow(w,2)*pow(1 + pow(w,4),4)*pow(z,6)*pow(1 - pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*log(f(0,tl(sl)))*
        (67 - 3*pow(Pi,2) + 33*log(-(pow(sl,4)*pow(-1 + pow(sl,4),4)*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)))) +
          33*log(-(f(0,tl(sl))/(pow(sl,4)*pow(-1 + pow(sl,4),4)*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)))))) -
       72*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) -
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) -
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) +
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) -
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) -
       72*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) -
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) -
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) +
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) -
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) -
       72*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) -
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) -
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) +
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) -
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) -
       72*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) -
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) -
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) +
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) -
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) -
       9*pow(c,2)*pow(Pi,2)*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(w,2)*pow(1 + pow(w,4),4)*pow(z,6)*
        pow(1 - pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
        (1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
        pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*(29.925925925925927 + (22*pow(Pi,2))/9. - 28*Zeta3)))/
   (9.*c*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*z*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
     pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
     pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double NFLap(double w, double sl, double c, double z) {
	return -((8192*c*sl*(1 + sl)*(1 + pow(sl,2))*w*(((28 + 3*pow(Pi,2))*pow(-1 + sl,3)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*pow(w,2)*pow(1 + pow(w,4),4)*pow(-1 + z,3)*pow(z,10)*pow(1 + z,3)*
		          pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6))/(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) +
		       (12*(-1 + sl)*pow(w,2)*pow(1 + pow(w,4),4)*pow(z,10)*pow(-1 + pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*log(f(0,tl(sl)))*
		          (5 + 3*log(-(pow(sl,4)*pow(-1 + pow(sl,4),4)*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)))) +
		            3*log(-(f(0,tl(sl))/(pow(sl,4)*pow(-1 + pow(sl,4),4)*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)))))))/
		        (sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
		       (108*(1 - sl)*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) -
		            (-1 + pow(w,4))*pow(z,8))*(pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
		             (1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
		            pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))))/
		        (pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
		          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)) -
		       (108*(1 - sl)*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) -
		            (-1 + pow(w,4))*pow(z,8))*(pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
		             (1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
		            pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))))/
		        (pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
		          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)) -
		       (108*(1 - sl)*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) -
		            (-1 + pow(w,4))*pow(z,8))*(pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
		             (1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
		            pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))))/
		        (pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
		          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)) -
		       (108*(1 - sl)*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) -
		            (-1 + pow(w,4))*pow(z,8))*(pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
		             (1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
		            pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))))/
		        (pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
		          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2))))/
		   (27.*pow(1 + pow(w,4),3)*pow(z,5)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)));
}

double CFLap(double x, double s, double a, double b) {
	return 1.;
}

double CAMom(double w, double sl, double c, double z) {
	return -((1024*(1 - sl)*sl*(1 + sl)*(1 + pow(sl,2))*w*(-8*pow(c,2)*Pi*pow(w,2)*pow(1 + pow(w,4),4)*pow(z,6)*pow(1 - pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
        (1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
        sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*log(f(0,tl(sl)))*
        (67 - 3*pow(Pi,2) + 33*log(-(pow(sl,4)*pow(-1 + pow(sl,4),4)*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)))) +
          33*log(-(f(0,tl(sl))/(pow(sl,4)*pow(-1 + pow(sl,4),4)*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)))))) -
       72*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) -
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) -
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) +
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) -
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) -
       72*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) -
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) -
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) +
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) -
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) -
       72*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) -
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) -
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) +
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) -
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) -
       72*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
        (2*pow(c,4)*pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
           pow(2 - 4*pow(z,2) + 6*pow(z,4) - 4*pow(z,6) + pow(z,8) - 2*pow(w,4)*pow(-1 + pow(z,2),4) + pow(w,8)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)),2) -
          pow(1 + pow(w,4),2)*(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*
           (1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))))*
           (2*(1 + pow(c,4))*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) -
             pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2) +
             pow(c,2)*pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)) -
             2*(1 + pow(c,4))*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2))
             ))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))) -
       9*pow(c,2)*pow(Pi,2)*pow(-1 + sl,2)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(w,2)*pow(1 + pow(w,4),4)*pow(z,6)*
        pow(1 - pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)*
        (1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8))*
        pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
        pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)*(29.925925925925927 - (22*pow(Pi,2))/9. - 28*Zeta3)))/
   (9.*c*pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(w,4),3)*z*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
     pow(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) - (-1 + pow(w,4))*pow(z,8),2)*
     pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*
     pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)));
}

double NFMom(double w, double sl, double c, double z) {
	return -((8192*c*sl*(1 + sl)*(1 + pow(sl,2))*w*(((28 - 3*pow(Pi,2))*pow(-1 + sl,3)*pow(sl,2)*pow(1 + sl,2)*pow(1 + pow(sl,2),2)*pow(w,2)*pow(1 + pow(w,4),4)*pow(-1 + z,3)*pow(z,10)*pow(1 + z,3)*
          pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6))/(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))) +
       (12*(-1 + sl)*pow(w,2)*pow(1 + pow(w,4),4)*pow(z,10)*pow(-1 + pow(z,2),3)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),6)*log(f(0,tl(sl)))*
          (5 + 3*log(-(pow(sl,4)*pow(-1 + pow(sl,4),4)*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)))) +
            3*log(-(f(0,tl(sl))/(pow(sl,4)*pow(-1 + pow(sl,4),4)*(-4 + 6*pow(sl,4) - 4*pow(sl,8) + pow(sl,12)))))))/
        (sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*(Pi - Pi*(-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
       (108*(1 - sl)*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) -
            (-1 + pow(w,4))*pow(z,8))*(pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
             (1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
            pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))))/
        (pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)) -
       (108*(1 - sl)*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) -
            (-1 + pow(w,4))*pow(z,8))*(pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
             (1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
            pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FA(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))))/
        (pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)) -
       (108*(1 - sl)*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) -
            (-1 + pow(w,4))*pow(z,8))*(pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
             (1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
            pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk1(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))))/
        (pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2)) -
       (108*(1 - sl)*(1 - z)*(1 + z)*(2 - pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))*(1 + 4*(-1 + pow(w,4))*pow(z,2) - 6*(-1 + pow(w,4))*pow(z,4) + 4*(-1 + pow(w,4))*pow(z,6) -
            (-1 + pow(w,4))*pow(z,8))*(pow(1 + pow(w,4),2)*pow(z,4)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),2)*
             (1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))*(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)))) -
            pow(c,2)*pow(-1 + pow(-1 + (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2),2))*log(FB(v(w),tl(sl),0,Tk2(T(u(z),v(w)),0,tl(sl)),u(z),b(c))/f(0,tl(sl))))/
        (pow(Pi,2)*sqrt(2 - pow(sl,4))*sqrt(2 - 2*pow(sl,4) + pow(sl,8))*pow(1 + pow(c,2) - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4)),2)*
          sqrt(1 - pow(w,4)*pow(z,2)*(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6)))*pow(1 + pow(c,2)*(1 - (-1 + pow(w,4))*pow(z,2)*(-2 + pow(z,2))*(2 - 2*pow(z,2) + pow(z,4))),2))))/
   (27.*pow(1 + pow(w,4),3)*pow(z,5)*pow(-4 + 6*pow(z,2) - 4*pow(z,4) + pow(z,6),4)));
}

double CFMom(double x, double s, double a, double b) {
	return 1.;
}
